<?
/* --------------------------------------------------------------------
   Copyright (c) 2008-2012 Daniel Pedemont (dan@pedemont.net)
   -------------------------------------------------------------------- */
/**
 * stream local
 *
 * stream example 101 (no sockets no signals)
 *
 * @link http://dev.pedemont.com/sonic/
 * @link http://dev.pedemont.com/sonic/downloads/src/lib/streams/sonic.stream.local.php
 * @package sonic_stream
 * @version 0.1.6
 * @abstract local daemon example
*/

define('SONIC_LOCAL_VERSION', '0.1.6');

//class SONIC_STRAM_[NAME]
//
//NB, function names in rotate mode have no protection,
//    so dont use generic function names for clash safety

class SONIC_STREAM_local extends SONIC_stream
{
  /**
   * stream main
   *
   * @see SONIC_stream::sonic_stream_main()
  */
  function sonic_stream_main()
  {
    //idle isnt really used by anything yet,
    //if you want to mark for future handling
    //just set around the critical areas, eg. I/O stuff
    //ie. dont blanket cover entire process flow
    //    with idle set to true
//    $this->idle = false;
    $i = 0;

//    var_dump($this->config);
    $stream_config = $this->config["stream_config"];

//      echo "pid=".$pid.", posix_getpid()=".posix_getpid().", posix_getppid()=".posix_getppid()."\n";

    $sleep = $stream_config["sleep_seconds"];
    $sleep += 0;

    if ($sleep);
    else
      $sleep = 30; //seconds

    if ($this->verbose > 0)
    {
      if ($msg = $stream_config["msg"])
        $msg .= "\n";
      else
        $msg = "message from local init\n";

      if ($msg_sleep = $stream_config["sleep_msg"])
        $msg_sleep .= "\n";
      else
        $msg_sleep = "sleep message from local ({$sleep}seconds)\n";
    }

    do
    {
      //flushes output, mainly useful when output mode set as 'buffer'
      //not strictly needed either
      $this->sonic_stream_buffer();

      $i++;

      if ($this->verbose > 0)
        echo "= [".($this->pcntl_loaded ? posix_getpid() : getmypid())."] ";

      if ($i < 2)
      {
        if ($this->verbose > 0)
          echo $msg;
      }
      else //if i < 2
      {
        if ($this->verbose > 0)
          echo $msg_sleep;

        sleep($sleep);

        break;
      }
    } while (true);

    //idle->NYA
//    $this->idle = true;
  }

}

?>
